ASPx.IS(function(ASPx, dx, DevExpress){
(function () {
 function IntersectionObserversManager() {
  this.rootElementToObserverMap = new Map();
  this.elementToHandlerMap = new Map();
  this.clearInvalidElementsInterval = null;
  this.clearInvalidElementsPeriod = 5000;
  this.AddTargetElement = function (element, rootElement, visibilityChangedHandler) {
   this.addTargetElementCore(element, rootElement, visibilityChangedHandler);
  };
  this.SubscribeElemensVisibilityChangeInBrowserWindow = function (element, visibilityChangedHandler) {
   this.addTargetElementCore(element, null, visibilityChangedHandler);
  };
  this.initializeObserver = function (rootElement) {
   if(!this.rootElementToObserverMap.get(rootElement)) {
    var options = {
     root: rootElement,
     rootMargin: '-1px',
     threshold: 0.0 
    };
    var observer = new IntersectionObserver(this.visibilityChanged.bind(this), options);
    this.rootElementToObserverMap.set(rootElement, observer);
   }
  };
  this.addTargetElementCore = function (element, rootElement, visibilityChangedHandler) {
   this.initializeObserver(rootElement);
   if(!this.isAlreadyObserved(element)) {
    var observer = this.rootElementToObserverMap.get(rootElement);
    if(observer) {
     observer.observe(element);
     this.setObservedMarker(element);
     this.setElementVisibilityChangedHandler(element, visibilityChangedHandler, observer);
     if(this.clearInvalidElementsInterval === null) {
      this.clearInvalidElementsInterval = setInterval(this.removeDeletedElements.bind(this), this.clearInvalidElementsPeriod);
     }
    }
   }
  };
  this.visibilityChanged = function (entries, observer) {
   entries.forEach(function (entry) {
    if(ASPx.IsExistsElement(entry.target)){
     var handler = this.elementToHandlerMap.get(observer).get(entry.target);
     if(handler) {
      handler(entry.isIntersecting);
     }
    }
   }.bind(this));
  };
  this.removeDeletedElements = function () {
   this.elementToHandlerMap.forEach(function(elements, observer) {
    elements.forEach(function(handler, element) {
     if(!ASPx.IsExistsElement(element)) {
      elements.delete(element);
     }
    }.bind(this));
    if(elements.size === 0) {
     this.elementToHandlerMap.delete(observer);
    }
   }.bind(this));
   if(this.elementToHandlerMap.size === 0) {
    clearInterval(this.clearInvalidElementsInterval);
    this.clearInvalidElementsInterval = null;
   }
  };
  this.setElementVisibilityChangedHandler = function (element, visibilityChangedHandler, observer) {
   if(!this.elementToHandlerMap.get(observer)) {
    this.elementToHandlerMap.set(observer, new Map());
   }
   this.elementToHandlerMap.get(observer).set(element, visibilityChangedHandler);
  };
  this.isAlreadyObserved = function (element) {
   return !!element.dataset.observed;
  };
  this.setObservedMarker = function (element) {
   element.dataset.observed = true;
  };
  this.reset = function () {
   this.rootElementToObserverMap.forEach(function(observer, rootElement) {
    observer.disconnect();
   }.bind(this));
   this.rootElementToObserverMap = new Map();
   this.elementToHandlerMap = new Map();
   this.clearInvalidElementsInterval = null;
   this.clearInvalidElementsPeriod = 5000;
  };
 }
 function IntersectionObserversManagerForOldBrowsers() {
  this.SubscribeElemensVisibilityChangeInBrowserWindow = function (element, visibilityChangedHandler) {
  };
 }
 ASPx.IntersectionObserversManager = ASPx.IntersectionObserversManager || ((typeof(IntersectionObserver) !== "undefined") ? new IntersectionObserversManager() : new IntersectionObserversManagerForOldBrowsers());
}
)(ASPx);
},0);
